###############
#Fonctions utilitaires
#################

def AlphaNum(ch):
    num=[]
    for car in ch:
        num.append(ord(car)-65)
    return num



def NumAlpha(liste):
    ch=""
    for n in liste:
        ch=ch+(chr(n+65))
    return ch



##################
#Fonctions techniques
##################

def CompteLettres(liste):
    n=0
    for i in liste:
        if (0<=i) and (i<=25):
            n=n+1
    return n


def RendPair(liste):
    n=CompteLettres(liste)
    if (n%2)==1:
        liste.append(0)



def ExtraireLettres(liste):
    res=[]
    n=len(liste)
    for i in range(n):
        j=liste[i]
        if (0<=j) and (j<=25):
            res.append([i,j])
    return res


def ChiffreHill(liste,a,b,c,d):
    n=len(liste)
    i=0
    while i<n:
        j=i+1
        x=liste[i][1]
        y=liste[j][1]
        z=(a*x+b*y)%26
        t=(c*x+d*y)%26
        liste[i][1]=z
        liste[j][1]=t
        i=i+2


def RemettreLettres(liste,extrait):
    for s in extrait:
        liste[s[0]]=s[1]



def Hill(liste,a,b,c,d):
    copie=list(liste)
    RendPair(copie)
    lettres=ExtraireLettres(copie)
    ChiffreHill(lettres,a,b,c,d)
    RemettreLettres(copie,lettres)
    return copie



def Inverse26(n):
    inv=0
    for i in range(26):
        m=n*i%26
        if m==1:
            inv=i
    return inv




def CleDechiffre(a,b,c,d):
    i=a*d-b*c
    j=Inverse26(i)
    e=(d*j)%26
    f=(-b*j)%26
    g=(-c*j)%26
    h=(a*j)%26
    return [e,f,g,h]



def BruteForce(liste):
    for a in range(26):
        for b in range(26):
            for c in range(26):
                for d in range(26):
                    i=(a*d-b*c)%26
                    j=Inverse26(i)
                    if j!=0:
                        print(NumAlpha(Hill(liste,a,b,c,d)))





def Espion(carclair1,carclair2,carchiffre1,carchiffre2,carclair3,carclair4,carchiffre3,carchiffre4):
    nclair1=ord(carclair1)-65
    nclair2=ord(carclair2)-65
    nchiffre1=ord(carchiffre1)-65
    nchiffre2=ord(carchiffre2)-65
    nclair3=ord(carclair3)-65
    nclair4=ord(carclair4)-65
    nchiffre3=ord(carchiffre3)-65
    nchiffre4=ord(carchiffre4)-65
    i=(nclair1*nclair4-nclair2*nclair3)%26
    print(i)
    j=Inverse26(i)
    print(j)
    a=(j*(nclair4*nchiffre1-nclair2*nchiffre3))%26
    print(a)
    b=(j*(-nclair3*nchiffre1+nclair1*nchiffre3))%26
    print(b)
    c=(j*(nclair4*nchiffre2-nclair2*nchiffre4))%26
    print(c)
    d=(j*(-nclair3*nchiffre2+nclair1*nchiffre4))%26
    print(d)
    [e,f,g,h]=CleDechiffre(a,b,c,d)
    print(e,f,g,h)
    return [e,f,g,h]



###################
#Procédures de Chiffrement/Déchiffrement/Décryptage
###################

def Chiffrer():
    messclair=input("Entrez votre message clair en majuscules et sans accents : ")
    messnum=AlphaNum(messclair)
    print(messnum)
    a=int(input("Choisissez la valeur de a : "))
    b=int(input("Choisissez la valeur de b : "))
    c=int(input("Choisissez la valeur de c : "))
    d=int(input("Choisissez la valeur de d : "))
    crypto=Hill(messnum,a,b,c,d)
    print(crypto)
    messcrypt=NumAlpha(crypto)
    print("Le message chiffré est : ",messcrypt)





def Dechiffrer():
    a=int(input("Entrez la valeur de a : "))
    b=int(input("Entrez la valeur de b : "))
    c=int(input("Choisissez la valeur de c : "))
    d=int(input("Choisissez la valeur de d : "))
    [e,f,g,h]=CleDechiffre(a,b,c,d)
    print("La clé de déchiffrement associée à la clé de chiffrement ",[[a,b],[c,d]]," est ",[[e,f],[g,h]])
    input()
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    print(cryptonum)
    decrypto=Hill(cryptonum,e,f,g,h)
    print(decrypto)
    mess=NumAlpha(decrypto)
    print("Le message clair est : ",mess)





def DecrypterEspion():
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    print("Vous pensez que le couple (L1,L2) est chiffré par le couple (M1,M2) et que le couple (L3,L4) est chiffré par le couple (M3,M4) ?")
    car1=input("Entrez L1 : ")
    car2=input("Entrez L2 : ")
    car3=input("Entrez M1 : ")
    car4=input("Entrez M2 : ")
    car5=input("Entrez L3 : ")
    car6=input("Entrez L4 : ")
    car7=input("Entrez M3 : ")
    car8=input("Entrez M4 : ")
    [e,f,g,h]=Espion(car1,car2,car3,car4,car5,car6,car7,car8)
    decrypto=Hill(cryptonum,e,f,g,h)
    mess=NumAlpha(decrypto)
    print("Si vous avez raison, et si les lettres devinées permettent le calcul, le message clair est : ",mess)






def DecrypterBrute():
    messchiffre=input("Entrez votre message chiffré en majuscules et sans accents : ")
    cryptonum=AlphaNum(messchiffre)
    print("Le message clair correspondant est dans la liste ci-dessous : ")
    BruteForce(cryptonum)
                 
